std::is_floating_point(3)

NAME
std::is_floating_point - std::is_floating_point

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_floating_point;
   Checks whether T is a floating-point type. Provides the member constant value which
   is equal to true, if T is the type float, double, long double, including any
   cv-qualified variants. Otherwise, value is equal to false.
   The behavior of a program that adds specializations for is_floating_point
   or is_floating_point_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T >
   inline constexpr bool is_floating_point_v = (since C++17)
   is_floating_point<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a floating-point type (possibly cv-qualified) , false
   [static] otherwise
            (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   template< class T >
   struct is_floating_point
        : std::integral_constant<
            bool,
            std::is_same<float, typename std::remove_cv<T>::type>::value ||
            std::is_same<double, typename std::remove_cv<T>::type>::value ||
            std::is_same<long double, typename std::remove_cv<T>::type>::value
        > {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 class A {};
 int main()
 {
     std::cout << std::boolalpha;
     std::cout << " A: " << std::is_floating_point<A>::value << '\n';
     std::cout << " float: " << std::is_floating_point<float>::value << '\n';
     std::cout << " float&: " << std::is_floating_point<float&>::value << '\n';
     std::cout << " double: " << std::is_floating_point<double>::value << '\n';
     std::cout << "double&: " << std::is_floating_point<double&>::value << '\n';
     std::cout << " int: " << std::is_floating_point<int>::value << '\n';
 }

Output:
       A: false
   float: true
  float&: false
  double: true
 double&: false
     int: false

See also
   is_iec559 identifies the IEC 559/IEEE 754 floating-point types
   [static] (public static member constant of std::numeric_limits<T>)
   is_integral checks if a type is an integral type
   (C++11) (class template)
   is_arithmetic checks if a type is an arithmetic type
   (C++11) (class template)
   floating_point specifies that a type is a floating-point type
   (C++20) (concept)